/***********************************************************************************************************************
 *
 * forceTen - open source geography
 * ================================
 *
 * Copyright (C) 2007-2010 by Tidalwave s.a.s.
 * Project home page: http://forceten.tidalwave.it
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: TileFactoryInfoAdapter.java,v 432868f2116d 2009/12/31 23:28:20 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.geo.viewer.spi.jxmapviewer;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import java.net.MalformedURLException;
import org.jdesktop.swingx.mapviewer.TileFactoryInfo;
import it.tidalwave.geo.viewer.spi.TileProviderDescriptor;
import static it.tidalwave.geo.viewer.spi.TileProviderDescriptor.HorizontalLayout.*;
import static it.tidalwave.geo.viewer.spi.TileProviderDescriptor.VerticalLayout.*;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: TileFactoryInfoAdapter.java,v 432868f2116d 2009/12/31 23:28:20 fabrizio $
 *
 **********************************************************************************************************************/
public class TileFactoryInfoAdapter extends TileFactoryInfo
  {
    @Nonnull
    private final TileProviderDescriptor tileProviderDescriptor;

    public TileFactoryInfoAdapter (final @Nonnull TileProviderDescriptor tileProviderDescriptor)
      {
        super(tileProviderDescriptor.getMinZoomLevel(),
              tileProviderDescriptor.getMaxZoomLevel(),
              tileProviderDescriptor.getTopZoomLevel(),
              tileProviderDescriptor.getTileSize().width,
              tileProviderDescriptor.getHorizontalLayout() == RIGHT_TO_LEFT,
              tileProviderDescriptor.getVerticalLayout() == TOP_TO_BOTTOM,
              "",
              "",
              "",
              "");

        this.tileProviderDescriptor = tileProviderDescriptor;
      }

    @Override @Nonnull
    public String getTileUrl (final int x, final int y, final @Nonnegative int zoom)
      {
        try
          {
            return tileProviderDescriptor.getTileUrl(tileProviderDescriptor.getTopZoomLevel() - zoom, x, y).toExternalForm();
          }
        catch (MalformedURLException e)
          {
            throw new RuntimeException(e);
          }
      }
  }
